
#include<stdio.h>

int main( void )
{ 
   int year;        /* current year */
   int leapYear;    /* leap year, 1 = yes, 0 = no */
   int days;        /* total days in current month */
   int month;       /* current month */
   int space;       /* space counter */
   int dayPosition; /* starting day position of year */
   int dayNum;      /* counter for days of the month */

   /* loop until input is valid */
   do {
      printf( "Enter a calendar year between 1994 and 1999: " );
      scanf( "%d", &year );
   } while ( year < 1994 || year > 1999 ); /* end do...while */

   /* determine starting day position */
   switch ( year ) {

      case 1994:
         dayPosition = 7;
         break; /* exit switch */

      case 1995:
         dayPosition = 1;
         break; /* exit switch */

      case 1996:
         dayPosition = 2;
         break; /* exit switch */

      case 1997:       
         dayPosition = 4;
         break; /* exit switch */

      case 1998:
         dayPosition = 5;
         break; /* exit switch */

      case 1999:
         dayPosition = 6;
         break; /* exit switch */
   } /* end switch */

   /* check for leap years */
   if ( year % 400 == 0 ) {
      leapYear = 1;
   } /* end if */
   else if ( year % 4 == 0 && year % 100 != 0 ) {
      leapYear = 1;
   } /* end else if */
   else {
      leapYear = 0;
   } /* end else */

   /* loop through months and print calendar */
   for ( month = 1; month <= 12; month++ ) { 

      /* begin with the month */
      switch ( month ) {
         
         case 1:
            printf( "\n\nJanuary %d\n", year );
            days = 31;
            break; /* exit switch */

         case 2:
            printf( "\n\nFebruary %d\n", year );
            days = leapYear == 1 ? 29 : 28;
            break; /* exit switch */

         case 3:
            printf( "\n\nMarch %d\n", year );
            days = 31;
            break; /* exit switch */

         case 4:
            printf( "\n\nApril %d\n", year );
            days = 30;
            break; /* exit switch */

         case 5:
            printf( "\n\nMay %d\n", year );
            days = 31;
            break; /* exit switch */

         case 6:
            printf( "\n\nJune %d\n", year );
            days = 30;
            break; /* exit switch */

         case 7:
            printf( "\n\nJuly %d\n", year );
            days = 31;
            break; /* exit switch */

         case 8:
            printf( "\n\nAugust %d\n", year );
            days = 31;
            break; /* exit switch */

         case 9:
            printf( "\n\nSeptember %d\n", year );
            days = 30;
            break; /* exit switch */

         case 10:
            printf( "\n\nOctober %d\n", year );
            days = 31;
            break; /* exit switch */

         case 11:
            printf( "\n\nNovember %d\n", year );
            days = 30;
            break; /* exit switch */

         case 12:
            printf( "\n\nDecember %d\n", year );
            days = 31;
            break; /* exit switch */
      } /* end switch */

      printf( " S  M  T  W  R  F  S\n" ); /* print heads */

      /* move to proper space to begin printing month */
      for ( space = 1; space < dayPosition; space++ ) {
         printf( "   " );
      } /* end for */

      /* print days of the month */
      for ( dayNum = 1; dayNum <= days; dayNum++ ) { 
         printf( "%2d ", dayNum );

         /* if end of the week, start a new line */
         if ( dayPosition % 7 == 0 ) {
            printf( "\n" );
            dayPosition = 1; /* reset dayPosition */
         } /* end if */
         else {
            ++dayPosition;
         } /* end else */

      } /* end for */

   } /* end for */

   return 0; /* indicate successful termination */

} /* end main */

